//+------------------------------------------------------------------+
//|                                                       Sniper.mq4 |
//|                                          Copyright 2014, Kolosov |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright 2014, Kolosov"
#property link      ""
#property version   "1.00"
#property strict

// Basic parameters  
extern double take      =  30.0;    // Takep rofit 
extern double stop      =  15.0;    // Stop loss 
extern double lot       =  0.02;     //  summary lot  
extern bool   del       =  true;    // open 2 orders   ?
extern double sl_2      =  10.0;    // stop loss accelerating order   
extern int    magic     =  123;     // magic number orders   
       int    slippage  =  1;       // slippage 
       int    NumOfTry  =  3;       // Number of attempts of modification   

//Colors of buttons and panel     
color buy_clr    =  clrRoyalBlue;
color sel_clr    =  clrTomato;
color cls_clr    =  clrGreenYellow;
color rect_cl    =  clrDarkOrange;
color razg_cl    =  clrOrchid;
color turn_cl    =  clrWhiteSmoke;

// For buttons  
extern ENUM_BASE_CORNER InpCorner=  CORNER_RIGHT_UPPER;  // Schedule corner for a binding   
string           InpFont         =  "Calibri";           //Font 
int              InpFontSize     =  11;                  //FontSize   
color            InpColor        =  clrBlack;            // Color text  
color            InpBorderColor  =  clrNONE;             // Border Color  
bool             InpState        =  false;               //It is pressed/is wrung out /
bool             InpBack         =  false;               //Object on a background    
bool             InpSelection    =  false;               //To allocate for movements   
bool             InpHidden       =  true;                // It is hidden in the list of objects    
long             InpZOrder       =  0;                   // Priority on pressing by a mouse    

//For a rectangle   
ENUM_BORDER_TYPE InpBorder       =  BORDER_RAISED;       //Frame type  
ENUM_LINE_STYLE  InpStyle        =  STYLE_SOLID;         // Style of flat border   (Flat)
int              InpLineWidth    =  1;                   // Thickness of flat border    (Flat)
bool             InpBackRect     =  true;                //Object on a background    

// Coordinates of buttons and sizes    
int x_coor = 10;
int y_coor = 20;
int x_size = 65;
int y_size = 20;
int x_step = 5;
int y_step = 15;
int y_panl = 155;
int n      = 1;

// name 
string Button[7] = {"button_buy", "button_sell", "button_close", "button_razg", "turn_0", "turn_1", "turn_2"};
string Panel_INF[2] = {"inf_pn","inf_pn_turn"};
string Label[20] = {"Label_01","Label_02","Label_03","Label_04","Label_05","Label_06","Label_07","Label_08",
                    "Label_09","Label_10","Label_11","Label_12","Label_13","Label_14","Label_15","Label_16",
                    "Label_17","Label_18","Label_19","Label_20"};
string Button_Turn = "Temp_Button";

// Additional variables  
bool turn_bs = false;
bool turn_rz = false;
bool turn_pn = false;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
{
   // old or new points are used     
   if (Digits == 3 || Digits == 5) n = 10;
   
   // Installation of elements of management (buttons, info pad)    (, )
   DrawElement(0);
   UpdateInfo(0);
   
   return(INIT_SUCCEEDED);
}
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
{
   Comment("");
   DeleteAll(10);
}
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
{
   if (turn_bs) return;
   if (!turn_pn) UpdateInfo(0);
   else          UpdateInfo(1);
   
   // We check, whether there are stop loss ,   
   Check_Stops();
}
//+------------------------------------------------------------------+
//| ChartEvent function                                              |
//+------------------------------------------------------------------+
void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
{
   bool selected;
   //--- we will check an event for pressing of the button of a mouse      
   if (id == CHARTEVENT_OBJECT_CLICK) {
      string clickedChartObject = sparam;
      //--- if pressing on object with the name buttonID      buttonID
      // button  BUY
      if (clickedChartObject == Button[0]) {
         selected = ObjectGetInteger(0,Button[0],OBJPROP_STATE);
         //--- if the button is pressed   
         if (selected)  { 
            Buy_event();
            ObjectSetInteger(0,Button[0],OBJPROP_STATE,false);
         }
      }
      // button  SELL
      if (clickedChartObject == Button[1]) {
         selected = ObjectGetInteger(0,Button[1],OBJPROP_STATE);
         //--- if the button is pressed   
         if (selected)  { 
            Sell_event();
            ObjectSetInteger(0,Button[1],OBJPROP_STATE,false);
         }
      }
      // button  CLOSE ALL
      if (clickedChartObject == Button[2]) {
         selected = ObjectGetInteger(0,Button[2],OBJPROP_STATE);
         //--- if the button is pressed   
         if (selected)  { 
            Close_ALL(OP_BUY);
            Close_ALL(OP_SELL);
            ObjectSetInteger(0,Button[2],OBJPROP_STATE,false);
         }
      }
      // button accelaration  
      if (clickedChartObject == Button[3]) {
         selected = ObjectGetInteger(0,Button[3],OBJPROP_STATE);
         //---if the button is pressed    
         if (selected)  {
            if (ObjectGetString(0,Button[3],OBJPROP_TEXT) != "Inactive") {
               Razg_Event();
            }
            ObjectSetInteger(0,Button[2],OBJPROP_STATE,false);
         }
      }
      // The button hides all panel    
      if (clickedChartObject == Button[4]) {
         selected = ObjectGetInteger(0,Button[4],OBJPROP_STATE);
         //--- if the button is pressed   
         if (selected)  { 
            turn_bs = true;
            DeleteAll(10);
            DrawElement(2);
            ObjectSetInteger(0,Button[4],OBJPROP_STATE,true);
         } else {  
            turn_bs = false;
            DrawElement(0);
            if (turn_pn) UpdateInfo(1);
            else         UpdateInfo(0);
         }
      }
      // The button closes the accelaration button    
      if (clickedChartObject == Button[5]) {
         selected = ObjectGetInteger(0,Button[5],OBJPROP_STATE);
         //---   
         if (selected)  { 
            turn_rz = true;
            ObjectSetString(0,Button[3],OBJPROP_TEXT,"Inactive");
         } else {  
            turn_rz = false;
            DrawElement(4);
         }
      }
      // The button closes the information panel    
      if (clickedChartObject == Button[6]) {
         selected = ObjectGetInteger(0,Button[6],OBJPROP_STATE);
         //---if the button is pressed    
         if (selected)  { 
            turn_pn = true;
            DeleteAll(0);
            CreateObj();
            UpdateInfo(1);
         } else {  
            turn_pn = false;
            DeleteAll(1);
            DrawElement(5);
            UpdateInfo(0);
         }
      }

      ChartRedraw(); //we will forcibly redraw all objects on graphics       
   }
   
}
bool Buy_event()
{
   double lott = lot, minlot = MarketInfo(Symbol(),MODE_MINLOT);
   
   if (del) lott = 0.5 * lot;
   if (lott < minlot) lott = minlot;
   
   if (!OrderSend(Symbol(),OP_BUY,lott,Ask,slippage*n,0.0,0.0,"Main Buy #1",magic,0,clrBlue)) {
      Print("Error open Buy: " + IntegerToString(GetLastError(),0,' '));
      return (false);
   }
   
   if (!del) return (true);
   
   if (!OrderSend(Symbol(),OP_BUY,lott,Ask,slippage*n,0.0,0.0,"Main Buy #2",magic,0,clrBlue)) {
      Print("Error open Buy: " + IntegerToString(GetLastError(),0,' '));
      return (false);
   }
   
   return (true);
}

bool Sell_event()
{
   double lott = lot, minlot = MarketInfo(Symbol(),MODE_MINLOT);
   
   if (del) lott = 0.5 * lot;
   if (lott < minlot) lott = minlot;
   
   if (!OrderSend(Symbol(),OP_SELL,lott,Bid,slippage*n,0.0,0.0,"Main Sell #1",magic,0,clrRed)) {
      Print("Error open Sell: " + IntegerToString(GetLastError(),0,' '));
      return (false);
   }
   
   if (!del) return (true);
   
   if (!OrderSend(Symbol(),OP_SELL,lott,Bid,slippage*n,0.0,0.0,"Main Sell #2",magic,0,clrRed)) {
      Print("Error open Sell: " + IntegerToString(GetLastError(),0,' '));
      return (false);
   }
   
   return (true);
}
void Close_ALL(int type)
{
   if (OrdersTotal() > 0) {
      for (int i = OrdersTotal()-1; i >= 0; i--) {
         if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES)) {
            if (OrderMagicNumber() != magic || OrderSymbol() != Symbol()) continue;
         
            for (int it = 1; it <= NumOfTry; it++) {
               if (OrderType() == OP_BUY && type == OP_BUY) {
                  if (!OrderClose(OrderTicket(),OrderLots(),Bid,slippage*n,clrYellow)) 
                     Print("Failed to close order!");
                  else break;
               }
               if (OrderType() == OP_SELL && type == OP_SELL) {
                  if (!OrderClose(OrderTicket(),OrderLots(),Ask,slippage*n,clrYellow)) 
                     Print("Failed to close order!");
                  else break;
               }
            }
         }
      }   
   }
   return;
}
bool Razg_Event()
{
   int b = 0, s = 0;
   
   for (int i = OrdersTotal()-1; i >= 0; i--) {
      if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES)) {
         if (OrderSymbol() != Symbol() && OrderMagicNumber() != magic) continue;
         if (OrderSymbol() == Symbol() && OrderMagicNumber() == magic) {
            if (OrderType() == OP_BUY)  b++;
            if (OrderType() == OP_SELL) s++;
         }
      }
   }
   
   if (b != 0 && s != 0) {
      Print("Accelaration isn't possible since in the market already there is multidirectional orders");
      return (false);
   }
   
if (Profit() > 0) {
   if (b != 0) {
      if (!OrderSend(Symbol(),OP_SELL,razgon(),Bid,slippage*n,0.0,0.0,"Razgon",magic,0,clrRed)) {
         Print("Error open Sell (Accelaration): " + IntegerToString(GetLastError(),0,' '));
         return (false);
      }
   }
   
   if (s != 0) {
      if (!OrderSend(Symbol(),OP_BUY,razgon(),Ask,slippage*n,0.0,0.0,"Razgon",magic,0,clrBlue)) {
         Print("Error open Buy (Accelaration): " + IntegerToString(GetLastError(),0,' '));
         return (false);
      }
   }
}
   
   return (true);
}
//+------------------------------------------------------------------+
//| Set stops                                                        |
//+------------------------------------------------------------------+
void Check_Stops()
{  
   double tp = 0.0, sl = 0.0;
   
   for (int i = OrdersTotal()-1; i >= 0; i--) {
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
         if (OrderSymbol() != Symbol() && OrderMagicNumber() != magic) continue;        
         if (OrderSymbol() == Symbol() && OrderMagicNumber() == magic) {
            
            if (OrderType() == OP_BUY) {
               // Buy #1
               if (OrderComment() == "Main Buy #1") {
                  if (OrderTakeProfit() == 0.0 && OrderStopLoss() == 0.0) {
                     tp = OrderOpenPrice() + take*Point*n;
                     sl = OrderOpenPrice() - stop*Point*n;
                     ModifyOrder(-1, sl, tp, 0, "check TP and SL buy #1");
                  }
               }
               // Buy #2
               if (OrderComment() == "Main Buy #2") {
                  if (OrderTakeProfit() == 0.0 && OrderStopLoss() == 0.0) {
                     tp = OrderOpenPrice() + stop*Point*n;
                     sl = OrderOpenPrice() - stop*Point*n;
                     ModifyOrder(-1, sl, tp, 0, "check TP and SL buy #2");
                  }
               }
            }
            if (OrderType() == OP_SELL) {
               // Sell #1
               if (OrderComment() == "Main Sell #1") {
                  
                  if (OrderTakeProfit() == 0.0 && OrderStopLoss() == 0.0) {
                     tp = OrderOpenPrice() - take*Point*n; 
                     sl = OrderOpenPrice() + stop*Point*n;
                     ModifyOrder(-1, sl, tp, 0, "check TP and SL sell #1");
                  }
               }
               // Sell #2
               if (OrderComment() == "Main Sell #2") {
                  
                  if (OrderTakeProfit() == 0.0 && OrderStopLoss() == 0.0) {
                     tp = OrderOpenPrice() - stop*Point*n; 
                     sl = OrderOpenPrice() + stop*Point*n;
                     ModifyOrder(-1, sl, tp, 0, "check TP and SL sell #2");
                  }
               }
            }
         }
      }
   }
}
//+------------------------------------------------------------------+
void DrawElement(int type)
{
   // Buttons for folding of some elements     
   string text = "";
if (type == 2 || type == 0) {
   // The button for turning of all panel     
   text = CharToStr(244);
   int x_turn_0 = x_coor + 2*x_size + 2*x_step, y_turn_0 = y_coor;
   if (InpCorner == 1)  x_turn_0 = x_coor + 2*x_size + 2*x_step + y_size;
   if (InpCorner == 2)  y_turn_0 = y_coor + y_panl + 3*y_size + 3*x_step;
   if (InpCorner == 3) {x_turn_0 = x_coor + 2*x_size + 2*x_step + y_size; y_turn_0 = y_coor + y_panl + 3*y_size + 3*x_step;}
   
   if (!ButtonCreate(0,Button[4],0,x_turn_0,y_turn_0,y_size,y_size,InpCorner,text,"Wingdings",11,
      InpColor,turn_cl,InpBorderColor,InpState,InpBack,InpSelection,InpHidden,InpZOrder)) {
      return;
   }
   ChartRedraw();
   if (type == 2) return;
}
if (type == 0) {
   //     
   text = CharToStr(251);
   int x_turn_1 = x_coor + 2*x_size + 2*x_step, y_turn_1 = y_coor + 2*y_size + 2*x_step;
   if (InpCorner == 1)  x_turn_1 = x_coor + 2*x_size + 2*x_step + y_size;
   if (InpCorner == 2)  y_turn_1 = y_coor + y_panl + y_size + x_step;
   if (InpCorner == 3) {x_turn_1 = x_coor + 2*x_size + 2*x_step + y_size; y_turn_1 = y_coor + y_panl + y_size + x_step;}
   
   if (!ButtonCreate(0,Button[5],0,x_turn_1,y_turn_1,y_size,y_size,InpCorner,text,"Wingdings",11,
      InpColor,turn_cl,InpBorderColor,InpState,InpBack,InpSelection,InpHidden,InpZOrder)) {
      return;
   }
   //     
   text = CharToStr(251);
   int x_turn_2 = x_coor + 2*x_size + 2*x_step, y_turn_2 = y_coor + 3*y_size + 3*x_step;
   if (InpCorner == 1)  x_turn_2 = x_coor + 2*x_size + 2*x_step + y_size;
   if (InpCorner == 2)  y_turn_2 = y_coor + y_panl;
   if (InpCorner == 3) {x_turn_2 = x_coor + 2*x_size + 2*x_step + y_size; y_turn_2 = y_coor + y_panl;}
   
   if (!ButtonCreate(0,Button[6],0,x_turn_2,y_turn_2,y_size,y_size,InpCorner,text,"Wingdings",11,
      InpColor,turn_cl,InpBorderColor,InpState,InpBack,InpSelection,InpHidden,InpZOrder)) {
      return;
   }

   //-------------------------------------------------------------------------------------------

   // The button for buy   
   int x_buy = x_coor, y_buy = y_coor;   
   if (InpCorner == 1)  x_buy = x_coor + 2*x_size + x_step;
   if (InpCorner == 2)  y_buy = y_coor + y_panl + 3*y_size + 3*x_step;
   if (InpCorner == 3) {x_buy = x_coor + 2*x_size + x_step; y_buy = y_coor + y_panl + 3*y_size + 3*x_step;}
   
   text = "Buy " + DoubleToStr(lot,2);
   if (!ButtonCreate(0,Button[0],0,x_buy,y_buy,x_size,y_size,InpCorner,text,InpFont,InpFontSize,
      InpColor,buy_clr,InpBorderColor,InpState,InpBack,InpSelection,InpHidden,InpZOrder)) {
      return;
   }
   
   // The button for SELL   
   int x_sell = x_coor + x_size + x_step, y_sell = y_coor;
   if (InpCorner == 1)  x_sell = x_coor + x_size;
   if (InpCorner == 2)  y_sell = y_coor + y_panl + 3*y_size + 3*x_step;
   if (InpCorner == 3) {x_sell = x_coor + x_size; y_sell = y_coor + y_panl + 3*y_size + 3*x_step;}
   
   text = "Sell " + DoubleToStr(lot,2);
   if (!ButtonCreate(0,Button[1],0,x_sell,y_sell,x_size,y_size,InpCorner,text,InpFont,InpFontSize,
      InpColor,sel_clr,InpBorderColor,InpState,InpBack,InpSelection,InpHidden,InpZOrder)) {
      return;
   }
   
   // The button for closing of all ORDERS     
   int x_close = x_coor, y_close = y_coor + y_size + x_step;
   if (InpCorner == 1)  x_close = x_coor + 2*x_size + x_step;
   if (InpCorner == 2)  y_close = y_coor + y_panl + 2*y_size + 2*x_step;
   if (InpCorner == 3) {x_close = x_coor + 2*x_size + x_step; y_close = y_coor + y_panl + 2*y_size + 2*x_step;}
   
   text = "Close ALL";
   if (!ButtonCreate(0,Button[2],0,x_close,y_close,2*x_size+x_step,y_size,InpCorner,text,InpFont,InpFontSize,
      InpColor,cls_clr,InpBorderColor,InpState,InpBack,InpSelection,InpHidden,InpZOrder)) {
      return;
   }
   ChartRedraw();
}
if (type == 4 || type == 0) {
   // The button for accelaration   
   int x_razg = x_coor, y_razg = y_coor + 2*y_size + 2*x_step;
   if (InpCorner == 1)  x_razg = x_coor + 2*x_size + x_step;
   if (InpCorner == 2)  y_razg = y_coor + y_panl + y_size + x_step;
   if (InpCorner == 3) {x_razg = x_coor + 2*x_size + x_step; y_razg = y_coor + y_panl + y_size + x_step;}
   
   if (turn_rz) text = "Inactive";
   else         text = "Accelaration";// + DoubleToStr(razgon(),2);
   if (!ButtonCreate(0,Button[3],0,x_razg,y_razg,2*x_size+x_step,y_size,InpCorner,text,InpFont,InpFontSize,
      InpColor,razg_cl,InpBorderColor,InpState,InpBack,InpSelection,InpHidden,InpZOrder)) {
      return;
   }
   ChartRedraw();
   if (type == 4) return;
}
   //-------------------------------------------------------------------------------------------
if (type == 5 || type == 0) {
   if (turn_pn) return;
   // Info pad  
   int x_pn = x_coor, y_pn = y_coor + 3*y_size + 3*x_step;
   if (InpCorner == 1)  x_pn = x_coor + 2*x_size + x_step;
   if (InpCorner == 2)  y_pn = y_coor + y_panl;
   if (InpCorner == 3) {x_pn = x_coor + 2*x_size + x_step; y_pn = y_coor + y_panl;}
   
   if (!RectLabelCreate(0,Panel_INF[0],0,x_pn,y_pn,2*x_size + x_step,y_panl,rect_cl,InpBorder,InpCorner,
        InpColor,InpStyle,InpLineWidth,InpBackRect,InpSelection,InpHidden,InpZOrder)) {
      return;
   }
   ChartRedraw();
   if (type == 5) return;
}
   ChartRedraw();
}
void UpdateInfo(int type)
{
   // text on Info pad    
   string text = "";
   if (!turn_rz) ObjectSetString(0,Button[3],OBJPROP_TEXT," Accelaration" + DoubleToStr(razgon(),2));
   
   if (type == 1) {
      // Label 01
      int x_label_01 = x_coor + x_step, y_label_01 = y_coor + 3*y_size + (int)(1.5*y_step);
      if (InpCorner == 1)  x_label_01 = x_coor + 2*x_size;
      if (InpCorner == 2)  y_label_01 = y_coor + y_panl - (int)(0.5*y_step);
      if (InpCorner == 3) {x_label_01 = x_coor + 2*x_size; y_label_01 = y_coor + y_panl - (int)(0.5*y_step);}
   
      text = Symbol();
      LabelCreate(0,Label[0],0,x_label_01,y_label_01,InpCorner,text,InpFont,8,
            InpColor,0.0,ANCHOR_LEFT,false,InpSelection,InpHidden,InpZOrder);
      // Label 02
      int x_label_02 = x_coor + 2*x_size, y_label_02 = y_label_01;
      if (InpCorner == 1 || InpCorner == 3) x_label_02 = x_coor + x_step;
   
      text = "spread " + DoubleToStr(MarketInfo(Symbol(),MODE_SPREAD),2);
      LabelCreate(0,Label[1],0,x_label_02,y_label_02,InpCorner,text,InpFont,8,
           InpColor,0.0,ANCHOR_RIGHT,false,InpSelection,InpHidden,InpZOrder);
      
      return;
   }
   
   // Label 01
   int x_label_01 = x_coor + x_step, y_label_01 = y_coor + 3*y_size + (int)(1.5*y_step);
   if (InpCorner == 1)  x_label_01 = x_coor + 2*x_size;
   if (InpCorner == 2)  y_label_01 = y_coor + y_panl - (int)(0.5*y_step);
   if (InpCorner == 3) {x_label_01 = x_coor + 2*x_size; y_label_01 = y_coor + y_panl - (int)(0.5*y_step);}
   
   text = "Lot order";
   LabelCreate(0,Label[0],0,x_label_01,y_label_01,InpCorner,text,InpFont,8,
        InpColor,0.0,ANCHOR_LEFT,false,InpSelection,InpHidden,InpZOrder);
   // Label 02
   int x_label_02 = x_coor + 2*x_size, y_label_02 = y_label_01;
   if (InpCorner == 1 || InpCorner == 3) x_label_02 = x_coor + x_step;
   
   text = DoubleToStr(lot,2);
   LabelCreate(0,Label[1],0,x_label_02,y_label_02,InpCorner,text,InpFont,8,
        InpColor,0.0,ANCHOR_RIGHT,false,InpSelection,InpHidden,InpZOrder);
   //-------------------------------------------------------------------------------------------
   // Label 03
   int x_label_03 = x_label_01, y_label_03 = y_coor + 3*y_size + (int)(2.5*y_step);
   if (InpCorner == 2 || InpCorner == 3) y_label_03 = y_coor + y_panl - (int)(1.5*y_step);
   
   text = "Take profit";
   LabelCreate(0,Label[2],0,x_label_03,y_label_03,InpCorner,text,InpFont,8,
        InpColor,0.0,ANCHOR_LEFT,false,InpSelection,InpHidden,InpZOrder);
   // Label 04
   int x_label_04 = x_coor + 2*x_size, y_label_04 = y_label_03;
   if (InpCorner == 1 || InpCorner == 3) x_label_04 = x_coor + x_step;
   
   text = DoubleToStr(take,1);
   LabelCreate(0,Label[3],0,x_label_04,y_label_04,InpCorner,text,InpFont,8,
        InpColor,0.0,ANCHOR_RIGHT,false,InpSelection,InpHidden,InpZOrder);   
   //-------------------------------------------------------------------------------------------
   // Label 05
   int x_label_05 = x_label_01, y_label_05 = y_coor + 3*y_size + (int)(3.5*y_step);
   if (InpCorner == 2 || InpCorner == 3) y_label_05 = y_coor + y_panl - (int)(2.5*y_step);
   
   text = "Stop loss Accelaration";
   LabelCreate(0,Label[4],0,x_label_05,y_label_05,InpCorner,text,InpFont,8,
        InpColor,0.0,ANCHOR_LEFT,false,InpSelection,InpHidden,InpZOrder);
   // Label 06
   int x_label_06 = x_coor + 2*x_size, y_label_06 = y_label_05;
   if (InpCorner == 1 || InpCorner == 3) x_label_06 = x_coor + x_step;
   
   text = DoubleToStr(stop,1);
   LabelCreate(0,Label[5],0,x_label_06,y_label_06,InpCorner,text,InpFont,8,
        InpColor,0.0,ANCHOR_RIGHT,false,InpSelection,InpHidden,InpZOrder);  
   //-------------------------------------------------------------------------------------------
   // Label 07
   int x_label_07 = x_label_01, y_label_07 = y_coor + 3*y_size + (int)(4.5*y_step);
   if (InpCorner == 2 || InpCorner == 3) y_label_07 = y_coor + y_panl - (int)(3.5*y_step);
   
   text = "Stop loss";
   LabelCreate(0,Label[6],0,x_label_07,y_label_07,InpCorner,text,InpFont,8,
        InpColor,0.0,ANCHOR_LEFT,false,InpSelection,InpHidden,InpZOrder);
   // Label 08
   int x_label_08 = x_coor + 2*x_size, y_label_08 = y_label_07;
   if (InpCorner == 1 || InpCorner == 3) x_label_08 = x_coor + x_step;
   
   text = DoubleToStr(sl_2,1);
   LabelCreate(0,Label[7],0,x_label_08,y_label_08,InpCorner,text,InpFont,8,
        InpColor,0.0,ANCHOR_RIGHT,false,InpSelection,InpHidden,InpZOrder);  
   //-------------------------------------------------------------------------------------------
   // Label 09
   int x_label_09 = x_label_01, y_label_09 = y_coor + 3*y_size + (int)(5.5*y_step);
   if (InpCorner == 1)  x_label_09 = x_coor + 2*x_size;
   if (InpCorner == 2 || InpCorner == 3) y_label_09 = y_coor + y_panl - (int)(4.5*y_step);
   
   text = "------------------------------------------";
   LabelCreate(0,Label[8],0,x_label_09,y_label_09,InpCorner,text,InpFont,8,
        InpColor,0.0,ANCHOR_LEFT,false,InpSelection,InpHidden,InpZOrder);
   // Label 10
   //-------------------------------------------------------------------------------------------
   // Label 11
   int x_label_11 = x_label_01, y_label_11 = y_coor + 3*y_size + (int)(6.5*y_step);
   if (InpCorner == 2 || InpCorner == 3) y_label_11 = y_coor + y_panl - (int)(5.5*y_step);
   
   text = "Lots in market";
   LabelCreate(0,Label[10],0,x_label_11,y_label_11,InpCorner,text,InpFont,8,
        InpColor,0.0,ANCHOR_LEFT,false,InpSelection,InpHidden,InpZOrder);
   // Label 12
   int x_label_12 = x_coor + 2*x_size, y_label_12 = y_label_11;
   if (InpCorner == 1 || InpCorner == 3) x_label_12 = x_coor + x_step;
   
   text = DoubleToStr(Lot(),2);
   LabelCreate(0,Label[11],0,x_label_12,y_label_12,InpCorner,text,InpFont,8,
        InpColor,0.0,ANCHOR_RIGHT,false,InpSelection,InpHidden,InpZOrder);   
   //-------------------------------------------------------------------------------------------
   // Label 13
   int x_label_13 = x_label_01, y_label_13 = y_coor + 3*y_size + (int)(7.5*y_step);
   if (InpCorner == 2 || InpCorner == 3) y_label_13 = y_coor + y_panl - (int)(6.5*y_step);
   
   text = "Lot on Accelaration";
   LabelCreate(0,Label[12],0,x_label_13,y_label_13,InpCorner,text,InpFont,8,
        InpColor,0.0,ANCHOR_LEFT,false,InpSelection,InpHidden,InpZOrder);
   // Label 14
   int x_label_14 = x_coor + 2*x_size, y_label_14 = y_label_13;
   if (InpCorner == 1 || InpCorner == 3) x_label_14 = x_coor + x_step;
   
   text = DoubleToStr(razgon(),2);
   LabelCreate(0,Label[13],0,x_label_14,y_label_14,InpCorner,text,InpFont,8,
        InpColor,0.0,ANCHOR_RIGHT,false,InpSelection,InpHidden,InpZOrder); 
   //-------------------------------------------------------------------------------------------
   // Label 15
   int x_label_15 = x_label_01, y_label_15 = y_coor + 3*y_size + (int)(8.5*y_step);
   if (InpCorner == 2 || InpCorner == 3) y_label_15 = y_coor + y_panl - (int)(7.5*y_step);
   
   text = "Profit";
   LabelCreate(0,Label[14],0,x_label_15,y_label_15,InpCorner,text,InpFont,8,
        InpColor,0.0,ANCHOR_LEFT,false,InpSelection,InpHidden,InpZOrder);
   // Label 16
   int x_label_16 = x_coor + 2*x_size, y_label_16 = y_label_15;
   if (InpCorner == 1 || InpCorner == 3) x_label_16 = x_coor + x_step;
   
   text = DoubleToStr(Profit(),1) + " " + AccountCurrency();
   LabelCreate(0,Label[15],0,x_label_16,y_label_16,InpCorner,text,InpFont,8,
        InpColor,0.0,ANCHOR_RIGHT,false,InpSelection,InpHidden,InpZOrder); 
   //-------------------------------------------------------------------------------------------
   // Label 17
   int x_label_17 = x_label_01, y_label_17 = y_coor + 3*y_size + (int)(9.5*y_step);
   if (InpCorner == 2 || InpCorner == 3) y_label_17 = y_coor + y_panl - (int)(8.5*y_step);
   
   text = "Pips";
   LabelCreate(0,Label[16],0,x_label_17,y_label_17,InpCorner,text,InpFont,8,
        InpColor,0.0,ANCHOR_LEFT,false,InpSelection,InpHidden,InpZOrder);
   // Label 18
   int x_label_18 = x_coor + 2*x_size, y_label_18 = y_label_17;
   if (InpCorner == 1 || InpCorner == 3) x_label_18 = x_coor + x_step;
   
   text = DoubleToStr(Pips(),1) + " ";
   LabelCreate(0,Label[17],0,x_label_18,y_label_18,InpCorner,text,InpFont,8,
        InpColor,0.0,ANCHOR_RIGHT,false,InpSelection,InpHidden,InpZOrder);
   //-------------------------------------------------------------------------------------------
   // Label 19
   int x_label_19 = x_label_01, y_label_19 = y_coor + 3*y_size + (int)(10.5*y_step);
   if (InpCorner == 2 || InpCorner == 3) y_label_19 = y_coor + y_panl - (int)(9.5*y_step);
   
   text = "Percent";
   LabelCreate(0,Label[18],0,x_label_19,y_label_19,InpCorner,text,InpFont,8,
        InpColor,0.0,ANCHOR_LEFT,false,InpSelection,InpHidden,InpZOrder);
   // Label 20
   int x_label_20 = x_coor + 2*x_size, y_label_20 = y_label_19;
   if (InpCorner == 1 || InpCorner == 3) x_label_20 = x_coor + x_step;
   
   text = DoubleToStr(Percent(),1) + " %";
   LabelCreate(0,Label[19],0,x_label_20,y_label_20,InpCorner,text,InpFont,8,
        InpColor,0.0,ANCHOR_RIGHT,false,InpSelection,InpHidden,InpZOrder);
        
   ChartRedraw();
}
void CreateObj()
{
   // info pad  
   int x_pn = x_coor, y_pn = y_coor + 3*y_size + 3*x_step;
   if (InpCorner == 1)  x_pn = x_coor + 2*x_size + x_step;
   if (InpCorner == 2)  y_pn = y_coor + y_panl;
   if (InpCorner == 3) {x_pn = x_coor + 2*x_size + x_step; y_pn = y_coor + y_panl;}
   
   if (!RectLabelCreate(0,Panel_INF[0],0,x_pn,y_pn,2*x_size + x_step,y_size,rect_cl,InpBorder,InpCorner,
        InpColor,InpStyle,InpLineWidth,InpBackRect,InpSelection,InpHidden,InpZOrder)) {
      return;
   }
}
//+------------------------------------------------------------------+
//| Creates the button                                                    |
//+------------------------------------------------------------------+
bool ButtonCreate(const long              chart_ID=0,               // ID chart 
                  const string            name="Button",            // name button  
                  const int               sub_window=0,             // number subwinsow  
                  const int               x=0,                      // coordinate on axis X    X
                  const int               y=0,                      // coordinate on axis Y    Y
                  const int               width=50,                 // button width  
                  const int               height=18,                // button height  
                  const ENUM_BASE_CORNER  corner=CORNER_LEFT_UPPER, // schedule corner for a binding   
                  const string            text="Button",            // text 
                  const string            font="Arial",             // font 
                  const int               font_size=10,             // font size  
                  const color             clr=clrBlack,             // color text  
                  const color             back_clr=C'236,233,216',  // background color  
                  const color             border_clr=clrNONE,       // color border  
                  const bool              state=false,              // it is pressed/is wrung out /
                  const bool              back=false,               // on a background   
                  const bool              selection=false,          // to allocate for movements   
                  const bool              hidden=true,              // it is hidden in the list of objects    
                  const long              z_order=0)                // priority on pressing by a mouse    
{
   //---we will dump value of a mistake    
   ResetLastError();
   //--- will create the button  
   if (ObjectFind(name) == -1) {
      ObjectCreate(chart_ID,name,OBJ_BUTTON,sub_window,0,0);
   }
   
   ObjectSetInteger(chart_ID,name,OBJPROP_XDISTANCE,x);                 //will establish button coordinates   
   ObjectSetInteger(chart_ID,name,OBJPROP_YDISTANCE,y);
   ObjectSetInteger(chart_ID,name,OBJPROP_XSIZE,width);                 // establish the button size   
   ObjectSetInteger(chart_ID,name,OBJPROP_YSIZE,height);
   ObjectSetInteger(chart_ID,name,OBJPROP_CORNER,corner);               // establish a corner of the schedule concerning which point coordinates will be defined   ,      
   ObjectSetString( chart_ID,name,OBJPROP_TEXT,text);                   // establish text   
   ObjectSetString( chart_ID,name,OBJPROP_FONT,font);                   // establish  text font   
   ObjectSetInteger(chart_ID,name,OBJPROP_FONTSIZE,font_size);          // establish  font size   
   ObjectSetInteger(chart_ID,name,OBJPROP_COLOR,clr);                   // establish color of text   
   ObjectSetInteger(chart_ID,name,OBJPROP_BGCOLOR,back_clr);            // establish color of background   
   ObjectSetInteger(chart_ID,name,OBJPROP_BORDER_COLOR,border_clr);     // establish color of border   
   ObjectSetInteger(chart_ID,name,OBJPROP_BACK,back);                   // will display on forward (false) or the back (true) plan    (false)   (true) 
   ObjectSetInteger(chart_ID,name,OBJPROP_STATE,state);                 // will transfer the button to the set state     
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTABLE,selection);        // will include (true) or we will turn off (false) the mode of movement of the button by a mouse (true)   (false)    
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTED,selection);
   ObjectSetInteger(chart_ID,name,OBJPROP_HIDDEN,hidden);               // will hide (true) or will display (false) name of graphic object in the list of objects  (true)   (false)      
   ObjectSetInteger(chart_ID,name,OBJPROP_ZORDER,z_order);              // will establish a priority on receiving an event of pressing of a mouse on graphics         
   
   //--- successful performance  
   return(true);
}
//+------------------------------------------------------------------+
//| Deletes the button                                                      |
//+------------------------------------------------------------------+
bool ButtonDelete(const long   chart_ID=0,    // ID chart 
                  const string name="Button") // name button  
{
   //--- will throw value of a mistake   
   ResetLastError();
   //---will remove the button   
   if (ObjectFind(chart_ID,name) >= 0) 
      ObjectDelete(chart_ID,name);
   //--- successful performance  
   return(true);
}
//+------------------------------------------------------------------+
//| Creates a rectangular label                                         |
//+------------------------------------------------------------------+
bool RectLabelCreate(const long             chart_ID=0,               // ID chart 
                     const string           name="RectLabel",         // name label  
                     const int              sub_window=0,             // number subwindow  
                     const int              x=0,                      // coordinate on axis X    X    X
                     const int              y=0,                      // coordinate on axis X    Y    Y
                     const int              width=50,                 // width 
                     const int              height=18,                // height 
                     const color            back_clr=C'236,233,216',  // color background   
                     const ENUM_BORDER_TYPE border=BORDER_SUNKEN,     // border type  
                     const ENUM_BASE_CORNER corner=CORNER_LEFT_UPPER, // schedule corner for a binding    
                     const color            clr=clrRed,               // color of flat border (Flat)    (Flat)
                     const ENUM_LINE_STYLE  style=STYLE_SOLID,        // style of flat border   
                     const int              line_width=1,             // thickness of flat border   
                     const bool             back=false,               // on a background   
                     const bool             selection=false,          // to allocate for movement   
                     const bool             hidden=true,              // it is hidden in the list of objects    
                     const long             z_order=0)                // priority on pressing by a mouse    
{
   //--- we will dump value of a mistake   
   ResetLastError();
   //--- will create a rectangular  LABEL   
   if (ObjectFind(name) == -1)
      ObjectCreate(chart_ID,name,OBJ_RECTANGLE_LABEL,sub_window,0,0);

   ObjectSetInteger(chart_ID,name,OBJPROP_XDISTANCE,x);              //   
   ObjectSetInteger(chart_ID,name,OBJPROP_YDISTANCE,y);
   ObjectSetInteger(chart_ID,name,OBJPROP_XSIZE,width);              //   
   ObjectSetInteger(chart_ID,name,OBJPROP_YSIZE,height);
   ObjectSetInteger(chart_ID,name,OBJPROP_BGCOLOR,back_clr);         //   
   ObjectSetInteger(chart_ID,name,OBJPROP_BORDER_TYPE,border);       //   
   ObjectSetInteger(chart_ID,name,OBJPROP_CORNER,corner);            //   ,      
   ObjectSetInteger(chart_ID,name,OBJPROP_COLOR,clr);                //     (  Flat)
   ObjectSetInteger(chart_ID,name,OBJPROP_STYLE,style);              //     
   ObjectSetInteger(chart_ID,name,OBJPROP_WIDTH,line_width);         //    
   ObjectSetInteger(chart_ID,name,OBJPROP_BACK,back);                //    (false)   (true) 
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTABLE,selection);     //  (true)   (false)    
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTED,selection);
   ObjectSetInteger(chart_ID,name,OBJPROP_HIDDEN,hidden);            //  (true)   (false)      
   ObjectSetInteger(chart_ID,name,OBJPROP_ZORDER,z_order);           //         
   
   //---  
   return(true);
}
//+------------------------------------------------------------------+
//|                                         |
//+------------------------------------------------------------------+
bool RectLabelDelete(const long   chart_ID=0,       // ID 
                     const string name="RectLabel") //  
{
   //---   
   ResetLastError();
   //---  
   if (ObjectFind(chart_ID,name) >= 0) 
      ObjectDelete(chart_ID,name);
   //---  
   return(true);
}
//+------------------------------------------------------------------+
//|                                             |
//+------------------------------------------------------------------+
bool LabelCreate(const long              chart_ID=0,               // ID 
                 const string            name="Label",             //  
                 const int               sub_window=0,             //  
                 const int               x=0,                      //    X
                 const int               y=0,                      //    Y
                 const ENUM_BASE_CORNER  corner=CORNER_LEFT_UPPER, //    
                 const string            text="Label",             // 
                 const string            font="Arial",             // 
                 const int               font_size=10,             //  
                 const color             clr=clrRed,               // 
                 const double            angle=0.0,                //  
                 const ENUM_ANCHOR_POINT anchor=ANCHOR_LEFT_UPPER, //  
                 const bool              back=false,               //   
                 const bool              selection=false,          //   
                 const bool              hidden=true,              //    
                 const long              z_order=0)                //    
{
   //---   
   ResetLastError();
   //---   
   if (ObjectFind(chart_ID,name) == -1) 
      ObjectCreate(chart_ID,name,OBJ_LABEL,sub_window,0,0);

   ObjectSetInteger(chart_ID,name,OBJPROP_XDISTANCE,x);           //   
   ObjectSetInteger(chart_ID,name,OBJPROP_YDISTANCE,y);
   ObjectSetInteger(chart_ID,name,OBJPROP_CORNER,corner);         //   ,      
   ObjectSetString(chart_ID,name,OBJPROP_TEXT,text);              //  
   ObjectSetString(chart_ID,name,OBJPROP_FONT,font);              //   
   ObjectSetInteger(chart_ID,name,OBJPROP_FONTSIZE,font_size);    //   
   ObjectSetDouble(chart_ID,name,OBJPROP_ANGLE,angle);            //    
   ObjectSetInteger(chart_ID,name,OBJPROP_ANCHOR,anchor);         //   
   ObjectSetInteger(chart_ID,name,OBJPROP_COLOR,clr);             //  
   ObjectSetInteger(chart_ID,name,OBJPROP_BACK,back);             //    (false)   (true) 
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTABLE,selection);  //  (true)   (false)    
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTED,selection);
   ObjectSetInteger(chart_ID,name,OBJPROP_HIDDEN,hidden);         //  (true)   (false)      
   ObjectSetInteger(chart_ID,name,OBJPROP_ZORDER,z_order);        //         
   
   //---  
   return(true);
}
//+------------------------------------------------------------------+
//|                                             |
//+------------------------------------------------------------------+
bool LabelDelete(const long   chart_ID=0,   // ID 
                 const string name="Label") //  
{
   //---   
   ResetLastError();
   //---  
   if (ObjectFind(chart_ID,name) >= 0) 
      ObjectDelete(chart_ID,name);
   //---  
   return(true);
}
void DeleteAll(int type)
{
   if (type == 0) {
      for (int i = 0; i <  2; i++) RectLabelDelete(0, Panel_INF[i]);
      for (int i = 0; i < 20; i++) LabelDelete(0, Label[i]);
   } else if (type == 1) {
      for (int i = 0; i <  2; i++) RectLabelDelete(0, Panel_INF[i]);
      for (int i = 0; i < 20; i++) LabelDelete(0, Label[i]);
   } else if (type == 10) {
      for (int i = 0; i <  7; i++) ButtonDelete(0, Button[i]);
      for (int i = 0; i <  2; i++) RectLabelDelete(0, Panel_INF[i]);
      for (int i = 0; i < 20; i++) LabelDelete(0, Label[i]);
   }
}
double Profit()
{
   double temp = 0.0;

   for (int i = 0; i < OrdersTotal(); i++) {
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
         if (OrderSymbol() == Symbol()) {
            if (OrderMagicNumber() == magic) {
               temp += OrderProfit() + OrderCommission() + OrderSwap();
            }
         }
      }
   }
   return (temp);
}

double Pips()
{
   double temp = 0.0;
   
   for (int i = 0; i < OrdersTotal(); i++) {
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
         if (OrderSymbol() == Symbol()) {
            if (OrderMagicNumber() == magic) {
               if (OrderType() <= 1) {
                  temp += (OrderProfit() / OrderLots() / MarketInfo( OrderSymbol(), MODE_TICKVALUE )) / n;
               }
            }
         }
      }
   }
   
   return (temp);
}

double Percent()
{
   double temp = Profit() * 100.0 / AccountBalance();
   return (temp);
}

double Lot()
{
   double temp = 0.0;
   for (int i = 0; i < OrdersTotal(); i++) {
      if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES)) {
         if (OrderSymbol()      != Symbol()) continue;
         if (OrderMagicNumber() != magic)    continue;
         if (OrderType()         > 1)        continue;
         
         temp += OrderLots();   
      }
   } 
   return (temp);
}

double razgon()
{
   double lotb = 0.0;
   double lots = Lot();
   double tp = Pips() + sl_2;
   
   lotb = lots * tp / sl_2;
   
   if (lotb < lots) lotb = lots;
   
   int b = 0, s = 0;
   
   for (int i = OrdersTotal()-1; i >= 0; i--) {
      if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES)) {
         if (OrderSymbol() != Symbol() && OrderMagicNumber() != magic) continue;
         if (OrderSymbol() == Symbol() && OrderMagicNumber() == magic) {
            if (OrderType() == OP_BUY)  b++;
            if (OrderType() == OP_SELL) s++;
         }
      }
   }
   
   if (b != 0 && s != 0) lotb = lot;
   
   return (lotb);
}
//+----------------------------------------------------------------------------+
//|  author     : Kim Igor   . aka KimIV,  http://www.kimiv.ru   |
//+----------------------------------------------------------------------------+
//|  version   : 28.11.2006                                              |
//|   :     .           |
//|  Description: Modification of one previously chosen order.                 |
//+----------------------------------------------------------------------------+
//|  Parameters:                                      :               |
//|   pp - the price of installation of the order  pp -     |
//|    sl -                                                 |
//|    tp -                                                 |
//|    ex -                                                       |
//+----------------------------------------------------------------------------+
void ModifyOrder(double pp = -1, double sl = 0, double tp = 0, datetime ex = 0, string func = " ") 
{
   bool   fm;
   double op, pa, pb, os, ot;
   int    dg = (int)MarketInfo(OrderSymbol(), MODE_DIGITS), er, it;

   if (pp <= 0) pp = OrderOpenPrice();
   if (sl <  0) sl = OrderStopLoss();
   if (tp <  0) tp = OrderTakeProfit();
  
   pp = NormalizeDouble(pp, dg);
   sl = NormalizeDouble(sl, dg);
   tp = NormalizeDouble(tp, dg);
   op = NormalizeDouble(OrderOpenPrice() , dg);
   os = NormalizeDouble(OrderStopLoss()  , dg);
   ot = NormalizeDouble(OrderTakeProfit(), dg);

   if (pp != op || sl != os || tp != ot) {
      for (it = 1; it <= NumOfTry; it++) {
         if (!IsTesting() && (!IsExpertEnabled() || IsStopped())) break;
         while (!IsTradeAllowed()) Sleep(5000);
         RefreshRates();
         fm = OrderModify(OrderTicket(), pp, sl, tp, ex, clrGreen);
         if (fm) {
            Print("Modifying order at bid: " + func); break;
         } else {
            er = GetLastError();
            
            pa = MarketInfo(OrderSymbol(), MODE_ASK);
            pb = MarketInfo(OrderSymbol(), MODE_BID);
            Print("Error (",er,") modifying order at bid: ", func, ". Try ", it);
            
            Sleep(1000*10);
         }
      }
   }
}